----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 04/07/2017 10:17:17 AM
-- Design Name: 
-- Module Name: LedSignals - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LedSignals is
  Port ( clk : in STD_LOGIC;
         btn : in STD_LOGIC_vector(1 downto 0);
         led : out std_logic_vector(1 downto 0)
        );
end LedSignals;

architecture Behavioral of LedSignals is
component mpg is
    Port ( clk : in STD_LOGIC;
           btn : in STD_LOGIC_vector(1 downto 0);
           enable : out STD_LOGIC_vector(1 downto 0)
           );
end component;

constant CNT_MAX : integer := 499999;
signal cnt_1 : STD_LOGIC_VECTOR(26 downto 0):=(others=>'0');
signal cnt_2 : STD_LOGIC_VECTOR(26 downto 0):=(others=>'0');
signal blink_started_1 : std_logic := '1';
signal blink_started_2 : std_logic := '1';
signal blink_1 : std_logic := '0';
signal blink_2 : std_logic := '0';


signal mpg_en   : std_logic_vector(1 downto 0);
begin
Debouncer: mpg
    Port Map( 
        clk     => clk, 
        btn     => btn, 
        enable  => mpg_en 
    );
--BLINK led 1
process(clk, cnt_1)
    begin
        if rising_edge(clk) then
            if blink_started_1 = '1' then
                cnt_1 <= cnt_1 + 1; 
            else
                cnt_1 <= (others=>'0'); 
            end if;
        end if;
end process;
led(0) <= cnt_1(26);
--BLINK led 2
process(clk, cnt_2)
    begin
        if rising_edge(clk) then
            if blink_started_2 = '1' then
               cnt_2 <= cnt_2 + 1;
            else
               cnt_2 <= (others=>'0');  
            end if;
        end if;
end process;
led(1) <= cnt_2(26);

--listen to button pressed
process(clk,mpg_en)
    begin
         if rising_edge(clk) then
            if mpg_en(0) = '1' then
                blink_started_1 <= not blink_started_1;
            end if;
            if mpg_en(1) = '1' then
                blink_started_2 <= not blink_started_2;
            end if;
         end if;
end process;

end Behavioral;
